// Copyright (c) 2024 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// term_test.go
package expr

import (
	"fmt"
	"testing"
)

func TestString(t *testing.T) {
	tk1 := NewValueToken(SymInteger, "100", 100)
	tk2 := NewToken(SymPlus, "+")
	tk3 := NewValueToken(SymInteger, "50", 500)

	tree := NewAst()
	if gotErr := tree.addTokens(tk1, tk2, tk3); gotErr == nil {
		fmt.Println("Tree:", tree)
	} else {
		t.Errorf("err: got <%v>, want <nil>", gotErr)
	}
}

func TestGetRoom(t *testing.T) {
	tk1 := NewValueToken(SymInteger, "100", 100)

	tree := NewAst()
	if gotErr := tree.addTokens(tk1); gotErr == nil {
		fmt.Println("Tree-root room:", tree.root.getRoom())
	} else {
		t.Errorf("err: got <%v>, want <nil>", gotErr)
	}
}
func TestGetChildrenCount(t *testing.T) {
	tk1 := NewValueToken(SymInteger, "100", 100)

	tree := NewAst()
	if gotErr := tree.addTokens(tk1); gotErr == nil {
		fmt.Println("Tree-root children count:", tree.root.getChildrenCount())
	} else {
		t.Errorf("err: got <%v>, want <nil>", gotErr)
	}
}
